#!/bin/bash

if [ $# -eq 0 ]; then
    exit 0
fi

STATUS=$1

if [ $STATUS -eq 0 ]; then
    GRUB_HEADER_FILE="/etc/grub.d/00_header"
    if grep -q "set pcrval_sha256=" $GRUB_HEADER_FILE; then
        sed -i "s/set pcrval_sha256=.*/set kverify=1/g" $GRUB_HEADER_FILE
        update-grub
        exit 0
    fi
    exit 0
fi

set -e
if ! command -v tpm2_pcrread &> /dev/null
then
    echo "tpm2-tools could not be found"
    exit
fi

KERNEL_PCR=$(tpm2_pcrread sha256:23)

KERNEL_PCR_VALUE=$(echo $KERNEL_PCR | cut -d ' ' -f 3)

GRUB_HEADER_FILE="/etc/grub.d/00_header"


if grep -q "set pcrval_sha256=" $GRUB_HEADER_FILE; then
    sed -i "s/set pcrval_sha256=.*/set pcrval_sha256=\"$KERNEL_PCR_VALUE\"/g" $GRUB_HEADER_FILE
    update-grub
    exit 0

fi

sed -i "s/set kverify=.*/set pcrval_sha256=\"$KERNEL_PCR_VALUE\"/g" $GRUB_HEADER_FILE

update-grub
